* Bayes glms
drop _all
clear

use rwm1984
quietly summarize docvis, meanonly
generate cdoc = docvis - r(mean)
quietly summarize age, meanonly
generate cage = age - r(mean)
glm outwork female kids cdoc cage, family(binomial) link(logit) nolog

bayes, rseed(2017): ///
        glm outwork female kids cdoc cage, family(binomial) link(logit)

bayesmh outwork female kids cdoc cage, likelihood(logit) ///
	prior({outwork:}, normal(0,10000)) rseed(2017)

bayesstats ic

bayesgraph diagnostics {outwork: cdoc}

bayesgraph diagnostics {outwork: cage}

bayesstats ess

display ln(invlogit(0.6))
display ln(1/(1+exp(0.6)))

capture program drop blogitll
program blogitll
	version 15
	args lnf xb
	quietly {
		tempvar lnfj
		generate `lnfj' = ln(invlogit(cond($MH_y,`xb',-`xb'))) if $MH_touse
		summarize `lnfj' if $MH_touse, meanonly
		if r(N) < $MH_n {
			scalar `lnf' = .
			exit
		}
		scalar `lnf' = r(sum)
	}
end
bayesmh outwork female kids cdoc cage, llevaluator(blogitll) ///
	prior({outwork:}, flat) rseed(32842)

bayesstats ic

summarize cdoc cage

bayes, prior({outwork:female kids _cons}, normal(0, 1000)) ///
       prior({outwork:cdoc}, /// 
       logdensity(ln(6)-ln(6^2+({outwork_cdoc})^2)-ln(_pi))) ///
       prior({outwork:cage}, ///
       logdensity(ln(11)-ln(11^2+{outwork_cage}^2)-ln(_pi))) ///
       rseed(35841): glm outwork female kids cdoc cage, family(binomial)  

bayes, prior({outwork:cdoc}, /// 
       logdensity(ln(6)-ln(6^2+({outwork_cdoc})^2)-ln(_pi))) ///
       prior({outwork:cage}, ///
       logdensity(ln(11)-ln(11^2+{outwork_cage}^2)-ln(_pi))) ///
       rseed(35841): ///
       glm outwork female kids cdoc cage, family(binomial)  


bayesmh outwork female kids cdoc cage, likelihood(logit)	///
	prior({outwork:female kids _cons}, normal(0, 1000))	///
	prior({outwork:cdoc},	 				///
	logdensity(ln(6)-ln(6^2+({outwork_cdoc})^2)-ln(_pi)))	///
	prior({outwork:cage},					///
	logdensity(ln(11)-ln(11^2+{outwork_cage}^2)-ln(_pi)))	///
	rseed(35841)
bayesstats ic

bayesgraph diagnostics {outwork: cdoc}

bayesgraph diagnostics {outwork: cage}

use rwm1984, clear
quietly summarize docvis, meanonly
generate cdoc = docvis - r(mean)
quietly summarize age, meanonly
generate cage = age - r(mean)
bayesmh outwork female kids cdoc cage, likelihood(probit)  ///
	prior({outwork:}, flat) rseed(23840)
bayesstats ic

glm outwork female kids cdoc cage, family(binomial) link(probit) noheader nolog

capture program drop bprobitll
program bprobitll
	version 15
	args lnf xb
	quietly {
		tempvar lnfj
		generate `lnfj' = ln(normal(cond($MH_y,`xb',-`xb'))) if $MH_touse
		summarize `lnfj' if $MH_touse, meanonly
		if r(N) < $MH_n {
			scalar `lnf' = .
			exit
		}
		scalar `lnf' = r(sum)
	}
end

use rwm1984, clear
quietly summarize docvis, meanonly
generate cdoc = docvis - r(mean)
quietly summarize age, meanonly
generate cage = age - r(mean)
bayesmh outwork female kids cdoc cage, llevaluator(bprobitll) ///
	prior({outwork:}, flat) rseed(823408)

capture program drop bclogll
program bclogll
	version 15
	args lnf xb
	quietly {
		tempvar lnfj
		generate `lnfj' = cond($MH_y,ln(1-exp(-exp(`xb'))),-exp(`xb')) if $MH_touse
		summarize `lnfj' if $MH_touse, meanonly
		if r(N) < $MH_n {
			scalar `lnf' = .
			exit
		}
		scalar `lnf' = r(sum)
	}
end

use rwm1984, clear
quietly summarize docvis, meanonly
generate cdoc = docvis - r(mean)
quietly summarize age, meanonly
generate cage = age - r(mean)
bayesmh outwork female kids cdoc cage, llevaluator(bclogll) ///
	prior({outwork:}, flat) rseed(34872)

glm outwork female kids cdoc cage, family(binomial) link(cloglog) noheader nolog


use titanicgrp, clear
bayesmh survive i.age i.sex i.class, likelihood(binlogit(cases))	///
	prior({survive:}, flat) rseed(39422)

glm survive i.age i.sex i.class, family(binomial cases) noheader nolog

bayesmh survive i.age i.sex i.class, likelihood(binlogit(cases))	///
	prior({survive:}, flat)	thinning(4) rseed(39422)

capture program drop blogitll
program blogitll
	version 15
	args lnf xb
	quietly {
		tempvar lnfj
		local n $MH_extravars
		generate `lnfj' = lngamma(`n'+1) - lngamma($MY_y+1) - ///
			lngamma(`n'-$MH_y+1) + $MH_y*ln(invlogit(`xb')) + ///
			(`n' - $MH_y)*ln(invlogit(-`xb')) if $MH_touse
		summarize `lnfj' if $MH_touse,  meanonly
		if r(N) < $MH_n {
			scalar `lnf' = .
			exit
		}
		scalar `lnf' = r(sum)
	}
end
use titanicgrp, clear
bayesmh survive i.age i.sex i.class, llevaluator(blogitll, ///
	extravars(case)) prior({survive:}, flat) rseed(123)

use rwm1984, clear
egen sage = std(age)
bayesmh docvis outwork sage, likelihood(poisson) ///
	prior({docvis:},  normal(0,10000)) rseed(239048)

glm docvis outwork sage, family(poisson) nolog


capture program drop bpoill
program bpoill
	version 15
	args lnf xb
	quietly {
		tempvar lnfj
		local offset $MK_extravars
		if "`offset'" == "" {
			local offset 0
		}
		generate `lnfj' =  -exp(`xb'+`offset') + ///
			$MH_y * (`xb'+`offset') - ///
			lngamma($MH_y + 1) if $MH_touse
		summarize `lnfj' if $MH_touse, meanonly
		if r(N) < $MH_n {
			scalar `lnf' = .
			exit
		}
		scalar `lnf' = r(sum)
	}
end
use rwm1984, clear
egen sage = std(age)
bayesmh docvis outwork sage, llevaluator(bpoill) ///
	prior({docvis:}, flat) rseed(14)

capture program drop bpoifll
program bpoifll
	version 15
	args lnf xb
	quietly {
		tempvar lnfj
		local offset $MK_extravars
		if "`offset'" == "" {
			local offset 1
		}
		generate `lnfj' =  -exp(`xb'+ln(`offset')) + ///
			$MH_y * (`xb'+ln(`offset')) - ///
			lngamma($MH_y + 1) if $MH_touse
		summarize `lnfj' if $MH_touse, meanonly
		if r(N) < $MH_n {
			scalar `lnf' = .
			exit
		}
		scalar `lnf' = r(sum)
	}
end
use doll, clear
bayesmh deaths smokes, llevaluator(bpoifll, exrtavars(pyears)) ///
	prior({deaths:}, flat) rseed(80242)

glm deaths smokes, family(poisson) exposure(pyears) noheader nolog

use rwm1984, clear
tabulate edlevel

egen sage = std(age)
bayesmh docvis outwork sage i.edlevel, likelihood(poisson) ///
	prior({docvis:_cons i.edlevel}, flat) ///
	prior({docvis:sage}, normal(0,1)) ///
	prior({docvis:outwork}, beta(3,30)) rseed(14) ///
	block({docvis:i.edlevel})

glm docvis outwork sage i.edlevel, family(poisson) noheader nolog

use rwm1984, clear
set seed 54969
sample 10
egen sage = std(age)
bayesmh docvis outwork sage i.edlevel, likelihood(poisson) ///
	prior({docvis:_cons i.edlevel}, flat) ///
	prior({docvis:sage}, normal(0,1)) ///
	prior({docvis:outwork}, beta(3,30)) rseed(14) ///
	block({docvis:i.edlevel})

bayesgraph diagnostics {docvis: outwork}

bayesgraph diagnostics {docvis: sage}

capture program drop bnbll
program bnbll
	version 15
	args lnf xb lnalpha
	quietly {
		tempvar lnfj
		gen double `lnfj' = ln(nbinomialp(1/exp(`lnalpha'), $MH_y, ///
			1/(1+exp(`lnalpha'+`xb')) )) if $MH_touse
		summarize `lnfj' if $MH_touse, meanonly
		if r(N) < $MH_n {
			scalar `lnf' = .
			exit
		}
		scalar `lnf' = r(sum)
	}
end
use rwm1984, clear
egen sage = std(age)
bayesmh docvis outwork sage, llevaluator(bnbll, parameters({lnalpha})) ///
	prior({docvis:}, flat) ///
	prior({lnalpha}, uniform(0.001,5)) rseed(98342) init({lnalpha} 1)

bayesstats summary {docvis: outwork sage _cons} /// 
    (lnalpha: {lnalpha}) (alpha: exp({lnalpha}))

nbreg docvis outwork sage, nolog

webuse oxygen, clear
bayes, rseed(123): regress change group age

webuse oxygen, clear
bayesmh change group age, likelihood(normal({var})) ///
	prior({change:}, flat) prior({var}, jeffreys) rseed(123)

glm change group age, family(gaussian) nolog

bayesmh change group age, likelihood(normal({var}))  ///
	prior({change:}, flat) prior({var}, normal(0, 1)) rseed(123)

capture program drop bnormll
program bnormll
	version 15
	args lnf xb var
	quietly {
		tempvar  lnfj
		generate double `lnfj' = ln(normalden($MH_y, ///
			`xb', sqrt(`var'))) if $MH_touse
		summarize `lnfj' if $MH_touse, meanonly
		if r(N) < $MH_n {
			scalar `lnf' = .
			exit
		}
		scalar `lnf' = r(sum)
	}
end

webuse oxygen, clear
bayesmh change group age,  llevaluator(bnormll, parameters({var})) ///
	prior({change:}, flat) prior({var}, normal(0,1)) ///
	rseed(2015)

bayesmh change group age,  ///
	llevaluator(bnormll, parameters({var})) ///
	prior({change:}, normal(0,1000)) ///
	prior({var}, igamma(.001, .001)) rseed(123)



capture program drop bgammall
program bgammall
	version 15
	args lnf xb phi
	quietly  {
		tempvar lnfj
		generate double `lnfj' = (1/`phi')* log($MH_y/(`phi'/`xb')) - /*
			*/ ($MH_y/(`phi'/`xb')) - log($MH_y) - /*
			*/ lngamma(1/`phi') if $MH_touse
		summarize `lnfj' if $MH_touse, meanonly
		if r(N) < $MH_n {
			scalar `lnf' = .
			exit
		}
		scalar `lnf' = r(sum)
	}
end

use rwm1984, clear
egen sage = std(age)
bayesmh docvis outwork sage if docvis>0, ///
	llevaluator(bgammall, parameters({phi})) prior({docvis:} {phi}, flat) ///
	rseed(123) block({phi}) init({docvis:_cons} 1 {phi} 1)

glm docvis outwork sage if docvis>0, family(gamma) nolog

capture program drop bivgll
program bivgll
	version 15
	args lnf xb sig2
	quietly  {
		tempvar lnfj
		generate double `lnfj' = -0.5*($MH_y-1/sqrt(`xb'))^2/ ///
			(`sig2'/`xb'*$MH_y) ///
			-0.5*log(2*_pi*$MH_y^3*`sig2') if $MH_touse
		summarize `lnfj' if $MH_touse, meanonly
		if r(N) < $MH_n {
			scalar `lnf' = .
			exit
		}
		scalar `lnf' = r(sum)
	}
end

use rwm1984, clear
egen sage = std(age)
bayesmh docvis outwork sage if docvis>0, ///
	llevaluator(bivgll, parameters({sig2})) ///
	prior({docvis:} {sig2}, flat) block({sig2}) ///
	initial({docvis:_cons} 1 {sig2} 1) rseed(87324)


glm docvis outwork sage if docvis>0, family(igaussian) nolog

use rwm1984, clear
egen sdocvis = std(docvis)
egen sage    = std(age)
bayesmh edlevel sdocvis sage female, likelihood(ologit) ///
	prior({edlevel: sdocvis sage}, normal(0, 1)) ///
	prior({edlevel: female}, flat) ///
	prior({edlevel: _cut1 _cut2 _cut3}, flat) rseed(87324) dots 

ologit edlevel sdocvis sage female, nolog

capture program drop bpoi0ll

program  bpoi0ll
	version 15
	args lnf xb
	quietly {
		tempvar lnfj
		generate `lnfj' =  -exp(`xb') +  $MH_y * ///
			`xb' - lngamma($MH_y + 1) ///
			- log(1-exp(-exp(`xb'))) if $MH_touse
		summarize `lnfj' if $MH_touse, meanonly
		if r(N) < $MH_n {
			scalar `lnf' = .
			exit
		}
		scalar `lnf' = r(sum)
	}
end

use rwm1984, clear
quietly summarize age, meanonly
generate cage = age - r(mean)
bayesmh docvis cage if docvis>0, llevaluator(bpoi0ll) ///
	prior({docvis: }, flat) rseed(28734)

tpoisson docvis cage if docvis>0, nolog

/*
program bzinbll
        version 15
        args lnf xbnb xbl lnalpha
        tempvar lnfj
	tempname a
        scalar `a' = exp(`lnalpha')
        quietly generate `lnfj' =  log(invlogit(`xbl')              ///
                + (1-invlogit(`xbl'))/((1+`a'*exp(`xbnb'))^(1/`a'))) ///
                if $MH_y1 == 0 & $MH_touse
        quietly replace `lnfj' =  log(1-invlogit(`xbl')) ///
                + lngamma(1/`a' + $MH_y1)                 ///
                - lngamma($MH_y1 +1) - lngamma(1/`a')     ///
                + (1/`a') * log(1/(1+`a'*exp(`xbnb')))    ///
                + $MH_y1 * log(1-(1/(1+`a'*exp(`xbnb')))) ///
                if $MH_y1 > 0 & $MH_touse
        quietly summarize `lnfj', meanonly
        if r(N) < $MH_n {
                scalar `lnf' = .
                exit
        }
        scalar `lnf' = r(sum)
end */


program bzinbll
        version 15
        args lnf xbnb xbl lnalpha
        tempvar lnfj
	tempname a
        scalar `a' = exp(`lnalpha')
        generate `lnfj' =  cond($MH_y1, ///
			log(1-invlogit(`xbl')) ///
                + lngamma(1/`a' + $MH_y1 )                 ///
                - lngamma($MH_y1 +1) - lngamma(1/`a')     ///
                + (1/`a') * log(1/(1+`a'*exp(`xbnb')))    ///
                + $MH_y1 * log(1-(1/(1+`a'*exp(`xbnb')))),  ///
			log(invlogit(`xbl')              ///
                + (1-invlogit(`xbl'))/((1+`a'*exp(`xbnb'))^(1/`a')))) ///
            	if $MH_touse
        summarize `lnfj', meanonly
        if r(N) < $MH_n {
                scalar `lnf' = .
                exit
        }
        scalar `lnf' = r(sum)
end

use rwm1984, clear
egen sage = std(age)
gen docvis2 = docvis
bayesmh (docvis outwork female married) (inflate:docvis2 outwork sage) , ///
          llevaluator(bzinbll, param({lnalpha})) prior({docvis:}, flat) ///
          prior({inflate:}, flat)  prior({lnalpha},normal(0,1000))      ///
          block({docvis:}) block({inflate:}) burnin(5000) mcmcsize(8000) ///
          rseed(1944) title(Zero-inflated negative binomial)

* Display alpha dispersion parameter
matrix b = e(mean)
display exp(b[1,8])

zinb docvis outwork female married, inflate(outwork sage) nolog

capture program drop bfambpll
program bfambpll
	version 15
	args lnf xb1 xb2 lambda
	quietly {
		local y1 "$MH_y1"
		local y2 "$MH_y2"

		tempname dd
		tempvar ll mu1 mu2 
		generate double `mu1' = exp(`xb1') if $MH_touse
		generate double `mu2' = exp(`xb2') if $MH_touse
		scalar `dd'      = 1 - exp(-1)
		generate double `ll'  = `y1'*`xb1'+`y2'*`xb2'-`mu1' ///
                        -`mu2'- lngamma(`y1'+1) - lngamma(`y2'+1) + ///
			log(1+`lambda'*(exp(-`y1')-exp(-`dd'*`mu1')) * ///
			(exp(-`y2')-exp(-`dd'*`mu2'))) if $MH_touse

		summarize `ll' if $MH_touse, meanonly
		if r(N) < $MH_n {
			scalar `lnf' = .
			exit
		}
		scalar `lnf' = r(sum)
	}
end

use corrcounts, clear
bayesmh (ycp1 x11 x12) (ycp2 x21 x22),  ///
	llevaluator(bfambpll, parameters({lambda})) prior({ycp1:} {ycp2:}, flat) ///
	prior({lambda}, normal(0,100)) thinning(10) rseed(3423)

use rwm1984, clear
egen sage = std(age)
bayesmh (docvis outwork sage) (hospvis outwork sage), llevaluator(bfambpll, parameters({lambda}))  ///
	prior({docvis:} {hospvis:}, flat) prior({lambda}, normal(0,1000)) mcmcsize(50000) burnin(30000) ///
	rseed(23498)

bayesstats ess


capture program drop famoyepbll
program famoyepbll
	version 15
	args todo b lnf
	quietly {
		local y1 "$ML_y1"
		local y2 "$ML_y2"
		tempname lambda
		tempvar  xb1 xb2 
		mleval `xb1'     = `b', eq(1)
		mleval `xb2'     = `b', eq(2)
		mleval `lambda'  = `b', eq(3) scalar

		tempvar mu1 mu2 
		generate double `mu1' = exp(`xb1') if $ML_samp
		generate double `mu2' = exp(`xb2') if $ML_samp

		tempname dd
		scalar `dd'      = 1 - exp(-1)

		replace `lnf' = `y1'*`xb1'+`y2'*`xb2'-`mu1'-`mu2'- ///
			lngamma(`y1'+1) - lngamma(`y2'+1) + ///
			log(1+`lambda'*(exp(-`y1')-exp(-`dd'*`mu1')) * ///
			(exp(-`y2')-exp(-`dd'*`mu2'))) if $ML_samp
	}
end

use rwm1984, clear
egen sage = std(age)
quietly poisson docvis outwork sage
matrix a1 = e(b)
quietly poisson hospvis outwork sage
matrix a2 = e(b)
matrix tt = (0)
matrix aa = a1, a2, tt
ml model lf0 famoyepbll (docvis:docvis=outwork sage) (hospvis:hospvis=outwork sage) (lambda:)
ml init aa, copy
ml maximize, search(off) title(Famoye Biv Poisson regression) nolog


use rwm1984, clear
egen sage = std(age)
gen cons = 1
bayesmh docvis, noconstant ///
	likelihood(llf(cond(docvis==0, ln(invlogit({xb:}) +      ///
	(1-invlogit({xb:}))/(1+{alpha}*exp({xc:}))^(1/{alpha})), ///
	log(1-invlogit({xb:})) + lngamma(docvis+1/{alpha}) -     ///
	lngamma(docvis+1) - lngamma(1/{alpha}) +                 ///
	1/{alpha} * ln(1/(1+{alpha}*exp({xc:}))) +               ///
	docvis * ln(1-(1/(1+{alpha}*exp({xc:})))) )))            ///
	xbdefine(xb: outwork sage cons)                          ///
	xbdefine(xc: outwork female married cons)                ///
	prior({xb:} {xc:}, flat)                                 ///
	prior({alpha}, normal(0,100))                            ///
	init({alpha} 1) dots                                     ///
	mcmcs(20000) burnin(12000) thinning(3) rseed(1944)       
bayesstats ic
bayesstats ess


use rwm1984, clear
quietly summarize docvis, meanonly
generate cdoc = docvis - r(mean)
quietly summarize age, meanonly
generate cage = age - r(mean)
bayes, prior({outwork:}, flat) rseed(34872): /// 
glm outwork female kids cdoc cage, family(binomial) link(cloglog)

use rwm1984, clear
egen sage = std(age)
bayesmh docvis outwork sage, likelihood(poisson) ///
	prior({docvis:},  normal(0,10000)) rseed(239048)
	
bayesstats summary (outwork:exp({docvis:outwork})) (sage:exp({docvis:sage})) 


use rwm1984, clear
set seed 54969
sample 10
egen sage = std(age)
bayesmh docvis outwork sage i.edlevel, likelihood(poisson) ///
	prior({docvis:_cons i.edlevel}, flat) ///
	prior({docvis:sage}, normal(0,1)) ///
	prior({docvis:outwork}, beta(3,30)) rseed(14) ///
	block({docvis:i.edlevel})
bayesstats ess

bayes, rseed(4385): nbreg docvis outwork sage

bayesstats summary (alpha: exp({lnalpha}))

bayes, rseed(1944) prior({inflate:}, flat): ///
 zinb docvis outwork female married, inflate(outwork sage)
bayesstats summary (alpha: exp({lnalpha}))

use rwm1984, clear
quietly summarize docvis, meanonly
generate cdoc = docvis - r(mean)
quietly summarize age, meanonly
generate cage = age - r(mean)
bayesmh outwork, likelihood(llf(ln(invlogit(cond(outwork, ///
	{outwork: female kids cdoc cage}, -{outwork: female kids cdoc cage}))))) ///
	prior({outwork:}, flat) rseed(2017)

