* Logit Chapter
drop _all
clear

use heart01
glm death anterior hcabg kk2 kk3 kk4 age2-age4, family(binomial) nolog

glm death anterior hcabg kk2 kk3 kk4 age2-age4, family(binomial) eform irls nolog


logistic death anterior hcabg kk2 kk3 kk4 age2-age4, nolog 
estat classification

lroc, nograph

estat gof, group(10) table

quietly glm death anterior hcabg kk2 kk3 kk4 age2-age4, family(binomial) eform irls nolog
ereturn disp, eform(Odds Ratio)

predict double p                         /* p = predicted probability     */
replace anterior=anterior+1              /* increment anterior            */
predict double p1                        /* p1= pred prob with anterior+1 */
generate double or=(p1/(1-p1))/(p/(1-p)) /* Calculate ratio of odds       */ 
summarize or                             /* display odds ratio (anterior) */

replace anterior=anterior-1
quietly logistic death anterior hcabg kk2 kk3 kk4 age2-age4, nolog
display "Atkinson's R(anterior) = " as res (sqrt((_b[anterior]/_se[anterior]-2)/(2*abs(e(ll_0)))))

/*  warsaw.dta created from this -input
drop _all
input age total menarche
 9.21  376    0
10.21  200    0
10.58   93    0
10.83  120    2
11.08   90    2
11.33   88    5
11.58  105   10
11.83  111   17
12.08  100   16
12.33   93   29
12.58  100   39
12.83  108   51
13.08   99   47
13.33  106   67
13.58  105   81
13.83  117   88
14.08   98   79
14.33   97   90
14.58  120  113
14.83  102   95
15.08  122  117
15.33  111  107
15.58   94   92
15.83  114  112
17.58 1049 1049
end
*/

use warsaw, clear
list

generate proportion = menarche/total
glm proportion age
predict phat
label var phat "Linear association"
scatter proportion age || line phat age

glm menarche age, family(binomial total)

predict double phat2
replace phat2 = phat2/total
label var phat2 "Predicted proportion reaching menarche"
twoway (scatter phat2 age, msymbol(o)) (scatter proportion age, msymbol(.))

generate equal = (_n-1)/24
twoway (scatter phat2 proportion) (line equal equal), ///
ytitle("Predicted proportion") xtitle("Observed proportion")

input yes no cons school union class
 51   8 1 1 1 1
 51  35 2 1 1 1
 11   6 1 2 1 1
 23  15 2 2 1 1
142  37 1 1 2 1
 64  21 2 1 2 1
 37  11 1 2 2 1
 19  25 2 2 2 1
 31   8 1 1 1 2
 83  94 2 1 1 2
 34  16 1 2 1 2
106 143 2 2 1 2
 62  23 1 1 2 2
 57  54 2 1 2 2
 61  24 1 2 2 2
 99 110 2 2 2 2
end
* cons   "cons"   "not"
* school "more"   "min"
* union  "member" "none"
* class  "middle" "working"
generate total = yes+no
generate consnot   = cons==2
generate schoolmin = school==2
generate unionnone = union==2
generate classwork = class==2
*/

use eec, clear
glm yes consnot schoolmin unionnone classwork, family(binomial total)

glm yes consnot schoolmin unionnone classwork consnot#classwork, family(binomial total)

display chi2tail(1,1.16)

display chi2tail(1,1.216)
