* Ordered Outcome Chapter
drop _all

set obs 100
set seed 12345
generate double x1 = 3*runiform()+1
generate double x2 = 2*runiform()-1
generate double y = 1 + .5*x1 + 1.2*x2 + rnormal()
generate int ys = cond(y<=2.5,1,cond(y<=3,2,cond(y<=4,3,4)))

ologit ys x1 x2, nolog
estat ic
predict double (olpr1 olpr2 olpr3 olpr4), pr

oprobit ys x1 x2, nolog
estat ic
predict double (oppr1 oppr2 oppr3 oppr4), pr

oglm ys x1 x2, link(cloglog) nolog
estat ic
predict double (ocpr1 ocpr2 ocpr3 ocpr4), pr

oglm ys x1 x2, link(loglog) nolog
estat ic
predict double (ozpr1 ozpr2 ozpr3 ozpr4), pr

gologit2 ys x1 x2, nolog
estat ic

test [1=2], notest
test [1=3], accumulate

list ys olpr1 oppr1 ocpr1 ozpr1 in 55/62

list ys olpr2 oppr2 ocpr2 ozpr2 in 55/62

list ys olpr3 oppr3 ocpr3 ozpr3 in 55/62

list ys olpr4 oppr4 ocpr4 ozpr4 in 55/62

sysuse auto, clear
replace rep78=3 if rep78<=3
drop if rep78==.
label define replab 3 "poor-avg" 4 "good" 5 "best"
label values rep78 replab
tabulate rep78

ologit rep78 foreign length displacement, nolog
estat ic

oprobit rep78 foreign length displacement, nolog
estat ic

gologit2 rep78 foreign length displacement
estat ic

test [poor-avg=good]

gologit2 rep78 foreign length displacement, link(logit) eform nolog

gologit2 rep78 foreign length displacement, link(probit) nolog
estat ic

gologit2 rep78 foreign length displacement, link(cloglog) nolog
estat ic
display exp(2.334334)  /* Exponentiated coefficient for Poor-Average foreign */
gologit2 rep78 foreign length displacement, link(loglog) nolog
estat ic
display exp(2.659394)  /* Exponentiated coefficient for Poor-Average foreign */


set more off
sysuse auto, clear
generate headsize = int(headroom+.5)
replace headsize = 4 if headsize==5
tabulate headsize

ologit headsize foreign mpg price displacement, nolog
brant

brant, detail

gologit2 headsize foreign mpg price displacement

gologit2 headsize foreign mpg price displacement, autofit lrforce

gologit2 headsize foreign mpg price displacement, npl(foreign)

use edreligion, clear
tabulate educlevel

ologit educlevel religious kids age male, nolog
estat ic

brant, detail

gologit2 educlevel religious kids age male, autofit lrforce nolog
estat ic

ocratio educlevel religious kids age male, link(logit)
aic

display "AIC Statistic = " (-2*(-605.4009+4)/997)

ocratio educlevel religious kids age male, link(logit) eform
aic

constraint 1 [3]religious = 2*[2]religious
constraint 2 [3]kids      = 2*[2]kids
constraint 3 [3]age       = 2*[2]age
constraint 4 [3]male      = 2*[2]male
mlogit educlevel religious kids age male, constraints(1,2,3,4) rrr nolog

